###############################################################################
# (c) 2006 Rico Schulte
# This Software is Free, use it where you want, when you want for whatever you want and modify it if you want but don't remove my copyright!
###############################################################################

import os
import sys

import config

def buildPackages(targetfile,oedir):
	for file in getIPKGs(oedir):
		data = getPackageMetadata(oedir,file)
		os.chdir(config.WORKING_DIR)
		addMetadataToFile(data)
	compressPackages()
	os.system("mv "+config.WORKING_DIR+"Packages.gz "+oedir)
	os.system("rm -r "+config.WORKING_DIR)
	
def getIPKGs(oedir):
	ipkglist=[]
	for file in os.listdir(oedir):
		if file.endswith(".ipk"):
			ipkglist.append(file)
	ipkglist.sort()
	return ipkglist

def getPackageMetadata(directory,ipkgfile): 
	print "extracting ",ipkgfile
	if os.path.isdir(config.WORKING_DIR) is not True:
		print "creating workingdir",config.WORKING_DIR
		os.mkdir(config.WORKING_DIR)
		
	tmpdir = config.WORKING_DIR+ipkgfile
	if os.path.isdir(tmpdir) is not True:
		os.mkdir(tmpdir)
	os.chdir(tmpdir)
	
	os.system("cp "+directory+ipkgfile+" "+tmpdir)
	os.system("ar -xf "+ipkgfile)
	os.system("gunzip -d control.tar.gz")
	os.system("tar -xf control.tar")
	fp = open("control")
	data = fp.read()
	fp.close
	data += "Filename: "+ipkgfile
	data += "\n\n"
	os.system("rm -r "+tmpdir)
	return data
	
def addMetadataToFile(data):
	#print "writing metadata", config.WORKING_DIR+"Packages"
	if os.path.isfile(config.WORKING_DIR+"Packages") is True:
		mode= "a"
	else:
		mode = "w"
	fp = open(config.WORKING_DIR+"Packages",mode)
	fp.write(data)
	fp.close()

def compressPackages():	
	#print "gzipping "+config.WORKING_DIR+"Packages"	
	os.system("gzip -f "+config.WORKING_DIR+"Packages")

if config.CONFIGURED is not True:
    print "configure config.py first!!!"
else:
	
	if sys.argv[0] == __file__:
		print "building %s of IPKG in %s"%(config.RESULTING_PACKAGES,config.PATH_TO_OE_IPK_DIR)
		buildPackages(config.RESULTING_PACKAGES,config.PATH_TO_OE_IPK_DIR)
		print "finished creating",config.RESULTING_PACKAGES